(function() {
	tpl.at = {};
	
	//
	// Add the titles of the test cases to the list to get them loaded to the table view
	//
	tpl.at.createData = function () {
		var acceptanceData = [
		//{title:'1000', hasChild:true},
		//{title:'1001', hasChild:true},
		{title:'timob_2135', hasChild:true, level:"acceptance"},
		{title:'timob_3136', hasChild:true, level:"acceptance"},
		{title:'timob_5298', hasChild:true, level:"acceptance"},
		{title:'timob_5330', hasChild:true, level:"acceptance"},
		{title:'timob_5900', hasChild:true, level:"acceptance"},
		{title:'timob_5970', hasChild:true, level:"acceptance"},
		{title:'timob_6244', hasChild:true, level:"acceptance"},
		{title:'timob_6493', hasChild:true, level:"acceptance"},
		{title:'timob_2802', hasChild:true, level:"acceptance"}
		]
		
		return acceptanceData;
	};
	
	//
	// TIMOB-2135
	// iOS: Audioplayer change state inconsistencies
	//
	tpl.at.timob_2135 = function (_window) 
	{
		var win = _window;
		var debug = Ti.API.debug;
		var info = Ti.API.info;
		
		Ti.Media.audioSessionMode = Ti.Media.AUDIO_SESSION_MODE_PLAYBACK;
		
		var url = Titanium.UI.createTextField({
		    value: 'http://www.parishiltonjustme.com/downloads/audio/08_Screwed.mp3',
		    color: '#336699',
		    returnKeyType: Titanium.UI.RETURNKEY_GO,
		    keyboardType: Titanium.UI.KEYBOARD_URL,
		    hintText: 'url',
		    textAlign: 'left',
		    clearOnEdit: true,
		    height: 35,
		    top: 10,
		    width: 300,
		    borderStyle: Titanium.UI.INPUT_BORDERSTYLE_ROUNDED
		});
		
		var streamButton = Titanium.UI.createButton({
		    title: 'Start Streaming',
		    top: 60,
		    width: 200,
		    height: 40
		});
		
		var pauseButton = Titanium.UI.createButton({
		    title: 'Pause Streaming',
		    top: 110,
		    width: 200,
		    height: 40,
		    enabled: false
		});
		
		var progressLabel = Titanium.UI.createLabel({
		    text: 'Time Played: Not Started',
		    top: 160,
		    left: 10,
		    height: 40,
		    width: 300,
		    color: '#555',
		    textAlignment: 'center'
		});
		
		var stateLabel = Titanium.UI.createLabel({
		    text: 'State: Not Started',
		    top: 180,
		    left: 10,
		    width: 300,
		    height: 40,
		    color: '#555'
		});
		
		win.add(url);
		win.add(streamButton);
		win.add(pauseButton);
		win.add(progressLabel);
		win.add(stateLabel);
		
		var streamer = Ti.Media.createAudioPlayer();
		
		streamButton.addEventListener('click', function() {
		    if (streamButton.title == 'Stop Stream') {
		        progressLabel.text = 'Stopped';
		        streamer.stop();
		        pauseButton.enabled = false;
		        pauseButton.title = 'Pause Streaming';
		        streamButton.title = "Start Streaming";
		    }
		    else {
		        progressLabel.text = 'Starting ...';
		        streamer.url = url.value;
		        streamer.start();
		        pauseButton.enabled = true;
		        pauseButton.title = 'Pause Streaming';
		        streamButton.title = "Stop Stream";
		    }
		});
		
		pauseButton.addEventListener('click', function() {
		    streamer.pause();
		    if (streamer.paused) {
		        pauseButton.title = 'Unpause Streaming';
		    }
		    else {
		        pauseButton.title = 'Pause Streaming';
		    }
		});
		
		streamer.addEventListener('change', function(e) {
		    stateLabel.text = 'State: '+e.description +' ('+e.state+')';
		    Ti.API.info('disc: ' + e.description);
		    Ti.API.info('state: ' + e.state);
		});
		
		streamer.addEventListener('progress', function(e) {
		    progressLabel.text = 'Time Played: ' + Math.round(e.progress) + ' seconds';
		});
		
		// save off current idle timer state
		var idleTimer = Ti.App.idleTimerDisabled;
		
		// while we're in this window don't let the app shutdown
		// when the screen is idle
		Ti.App.idleTimerDisabled = true;
		
		win.addEventListener('close', function() {
		    Ti.API.info("window was closed, idleTimer reset to = " + idleTimer);
		    
		    // restore previous idle state when closed
		    Ti.App.idleTimerDisabled = idleTimer;
		});
		
		return win;
	}
	
	// TIMOB-5298 - Can't play sounds repeatedly
	tpl.at.timob_5298 = function(_window) {
		var playCounter = 0;
		_window.backgroundColor = '#000';
		
		var button = Ti.UI.createButton({
			title:'click'
		});
		button.addEventListener('click', Playsound);
		_window.add(button);
		
		function Playsound(){
			playCounter++;
			Ti.API.info("Playing sound, nr: " + playCounter);
			var player =Ti.Media.createSound({
				url: "cat.mp3"
			});
			
			player.addEventListener('complete', function(e) {
				player.release();
				player = null;
				Ti.API.info("Sound played correctly");
			});
			player.play();
		}
		
		return _window;
	}
	
	//
	// TIMOB-5330
	// Ti.Media.Sound delay when using preload tag
	//
	tpl.at.timob_5330 = function (_window) {
		{
			var btn1 = Titanium.UI.createButton({
			    title:"1st",
			    height:33,
			    width:33,
			    left: 5,
			    bottom: 5
			});
			
			var btn2 = Titanium.UI.createButton({
			    title:"2nd",
			    height:33,
			    width:33,
			    left: 50,
			    bottom: 5
			});
			
			var label1 = Titanium.UI.createLabel({
			    color:'#999',
			    text:"",
			    font:{fontSize:20,fontFamily:'Helvetica Neue'},
			    textAlign:'center',
			    width:'auto'
			});
			
			_window.add(btn1);
			_window.add(btn2);
			_window.add(label1);
			
			// To elminate delays during sound engine initialization, create a sound, any sound, about 2 seconds before you first call 'play'
			Titanium.Media.createSound({url:"dtmf-1.mp3"});
			
			function go2(type) {
			    var sn = "dtmf-1.mp3";
				if (type == 2) {
				    sn = "dtmf-3.mp3";
				}
				label1.text = sn;
			    Ti.API.info(sn);	    
			    
				var snd = Titanium.Media.createSound({
			        isLooping:false,
			        url:sn,
			        // preload tag
			        preload: true
			    });
				snd.play();
			}
			
			btn1.addEventListener('click',function(e){
			    go2(1);
			});
			
			btn2.addEventListener('click',function(e){
			    go2(2);
			});
		}
		
		_window.fullscreen = true;
		return _window;
	}
	
	//
	// TIMOB-5900
	// Closing camera or gallery closes modal
	//
	tpl.at.timob_5900 = function (_window) {
		{
			var button1 = Titanium.UI.createButton(
			{
			    color: '#999',
			    title: 'Launch Modal',
			    width: '200dp',
			    height: '60dp'
			});
			
			_window.add(button1);
			
			button1.addEventListener("click", function()
			{
			    modal = Ti.UI.createWindow(
			    {
			        modal: true,
			        title: "modal"
			    });
			
			    var cameraButton = Ti.UI.createButton(
			    {
			        title: "camera",
			        top: "50dp",
			        width: "150dp",
			        height: "60dp"
			    });
			    
			    modal.add(cameraButton);
			    
			    imageViewResize = Ti.UI.createImageView(
			    {
			        top: "200dp",
			        height: "200dp",
			        width: "200dp"
			    });
			    
			    modal.add(imageViewResize);
			
			    cameraButton.addEventListener("click", function()
			    {
			        Titanium.Media.showCamera(
			        {
			            success: function(event)
			            {
			                imageViewResize.image = event.media;
			            },
			
			            error: function()
			            {
			            },
			
			            cancel: function()
			            {
			            },
			
			            saveToPhotoGallery: true,
			            allowEditing: true,
			            mediaTypes: [Ti.Media.MEDIA_TYPE_PHOTO],
			            showControls: true
			        });
			    });
			    
			    // exit button
			    var done = Titanium.UI.createButton({
					title:"Done",
					height: 50,
					width: 50,
					bottom: 0,
					right: 0
				});
				
				modal.add(done);
				
				done.addEventListener('click', function() {
					modal.close();
				});
			    
			    modal.open();
			});
		}
		
		_window.fullscreen = true;
		return _window;
	}
	
	//
	// TIMOB-5970
	// iOS: Audioplayer change state inconsistencies
	//
	tpl.at.timob_5970 = function (_window) 
	{
		_window.addEventListener('click', function(){
   
			Titanium.Media.openPhotoGallery({

				success : function(event) {
					alert('success');
				},
				cancel : function(cancel) {
					alert('cancel');
				},
				error : function(error) {
					alert('error');
				}
			});
			})

		return _window;
	}
	//
	// TIMOB-3136
	// This tests that the front camera is used when using Ti.Media.CAMERA_FRONT
	//
	tpl.at.timob_3136 = function (_window) 
	{
		if(Ti.Platform.osname != 'android') {
			
			_window.addEventListener('click', function() {

				Ti.Media.showCamera({
					mediaTypes : Ti.Media.MEDIA_TYPE_PHOTO
				});
				Ti.Media.switchCamera(Ti.Media.CAMERA_FRONT);
				Ti.Media.vibrate();
			})

		} else {
			var label = tpl.ui.getSkipLabel();
			_window.add(label);
		}
		
		return _window;
	}

	//
	// TIMOB-6244: Android: Video Player mediaControlStyle creation property ignored
	//

	tpl.at.timob_6244 = function(_window) {
		var moviePlayer = Ti.Media.createVideoPlayer({
			url : 'http://dts.podtrac.com/redirect.mp4/twit.cachefly.net/video/aaa/aaa0033/aaa0033_h264b_640x368_256.mp4',
			mediaControlStyle : Titanium.Media.VIDEO_CONTROL_EMBEDDED,
			scalingMode : Titanium.Media.VIDEO_SCALING_MODE_FILL,
			autoplay : true,
			backgroundColor : "blue"
		});

		_window.add(moviePlayer);
		return _window;
	}
	
	//
	// TIMOB-6493
	// iOS: Titanium.Media.takeScreenshot fails to orient captured image to reflect hardware orientation
	//
	tpl.at.timob_6493 = function (_window)
	{
		var win = _window;
		
		win.backgroundColor = "white";
		win.orientationModes = [Titanium.UI.LANDSCAPE_LEFT];
		
		var button = Ti.UI.createButton({
			title: 'Press to Take Screenshot!',
			borderColor:"red",
			borderWidth:10
		})
		
		button.addEventListener('click',function(){
			Titanium.Media.takeScreenshot(function(event){
				var screenShot = event.media;
				var img = Titanium.UI.createImageView({ image: screenShot });
				img.width = 50;
				img.height = 50;
				win.add(img);
			});
		});
		
		win.add(button);
		
		win.fullscreen = true;
		return win;
	}
	
	//
	// TIMOB-2802 is designed to test that movieControlStyle is deprecated and 
	// mediaControlStyle is working
	//
	tpl.at.timob_2802 = function(_window) {
		
		
		var activeMovie1 = Titanium.Media.createVideoPlayer({
			sourceType : Ti.Media.VIDEO_SOURCE_TYPE_FILE,
			url : 'movie.mp4',
			backgroundColor : '#000',
			scalingMode : Titanium.Media.VIDEO_SCALING_ASPECT_FIT,
			movieControlStyle : Titanium.Media.VIDEO_CONTROL_NONE
		});



		var activeMovie2 = Titanium.Media.createVideoPlayer({
			sourceType : Ti.Media.VIDEO_SOURCE_TYPE_FILE,
			url : 'movie.mp4',
			backgroundColor : '#000',
			scalingMode : Titanium.Media.VIDEO_SCALING_ASPECT_FIT,
			mediaControlStyle : Titanium.Media.VIDEO_CONTROL_NONE
		});

		_window.add(activeMovie2);




		return _window;
	}
		
})();